---
title: 'ARIA: button role'
slug: Web/Accessibility/ARIA/Roles/button_role
tags:
  - ARIA
  - ARIA Role
  - ARIA button
  - Accessibility
  - Button Role
  - Reference
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p class="summary"><span class="seoSummary">The <strong><a href="https://www.w3.org/WAI/PF/aria/roles#button">button</a></strong> role should be used for clickable elements that trigger a response when activated by the user. Adding <code>role="button"</code> will make an element appear as a button control to a screen reader. This role can be used in combination with the <code>aria-pressed</code> attribute to create toggle buttons.</span></p>

<pre class="brush: html">&lt;div id="saveChanges" tabindex="0" role="button" aria-pressed="false"&gt;Save&lt;/div&gt;</pre>

<p>The above example creates a simple button which is first in the focus order, though {{HTMLElement("button")}} or {{HTMLElement("input")}} with <code>type="button"</code> should be used for buttons:</p>

<pre class="brush: html">&lt;button id="saveChanges"&gt;Save&lt;/button&gt;</pre>

<div class="note">
<p><strong>Note</strong>: If using role="button" instead of the semantic <code>&lt;button&gt;</code> or <code>&lt;input type="button"&gt;</code> elements, you will need to make the element focusable and have to define event handlers for {{event("click")}} and {{event("keydown")}} events, including the <kbd>Enter</kbd> and <kbd>Space</kbd> keys, in order to process the user's input. See the <a href="https://www.w3.org/TR/wai-aria-practices/examples/button/button.html">official WAI-ARIA example code</a>.</p>
</div>

<h2 id="Description">Description</h2>

<p>The button role identifies an element as a button to screen readers. A button is a widget used to perform actions such as submitting a form, opening a dialog, cancelling an action, or performing a command such as inserting a new record or displaying information.</p>

<p>A common convention to inform users a button will launch a dialog is to append "…" (ellipsis) to the button's label, e.g., "Save as…".</p>

<p>In addition to the ordinary button widget, role="button" should be included when creating a toggle button or menu button using a non button element. A toggle button is a two-state button that can be either off (not pressed) or on (pressed). The <code>aria-pressed</code> attribute values of <code>true</code> or <code>false</code> identify a button as a toggle button. A menu button is a button that controls a menu and has an <code>aria-haspopup</code> property attribute set to either <code>menu</code> or <code>true</code>.</p>

<h3 class="highlight-spanned" id="Associated_ARIA_roles_states_and_properties"><span class="highlight-span">Associated ARIA roles, states, and properties</span></h3>

<dl>
 <dt><code><span class="highlight-span">aria-pressed</span></code></dt>
 <dd>Defines the button as a toggle button. The value of <code>aria-pressed</code> describes the state of the button. The values include <code>aria-pressed="false"</code> when a button is not currently pressed, <code><code>aria-pressed="true"</code></code> to indicate a button is currently pressed, and <code>aria-pressed="mixed"</code> if the button is considered to be partially pressed. If the attribute is omitted or set to its default value of <code><code>aria-pressed="undefined"</code></code>, the element does not support being pressed.</dd>
 <dt><code>aria-expanded</code></dt>
 <dd>If the button controls a grouping of other elements, the <code>aria-expanded</code> state indicates whether the controlled grouping is currently expanded or collapsed.  If the button has <code>aria-expanded="false"</code> set, the grouping is not currently expanded; If the button has <code>aria-expanded="true"</code> set, it is currently expanded; if the button has <code>aria-expanded="undefined"</code> set or the attribute is ommitted, it is not expandable.</dd>
</dl>

<h3 id="Basic_buttons">Basic buttons</h3>

<p>Buttons should always have an accessible name. For most buttons, this name will be the same as the text inside the button. In some cases, for example buttons represented by icons, the accessible name may be provided from the <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">aria-label</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute">aria-labelledby</a></code> attributes.</p>

<h3 id="Toggle_buttons">Toggle buttons</h3>

<p>A toggle button typically has two states: pressed and not pressed. A third mixed state is available for toggle buttons that control other elements, such as other toggle buttons or checkboxes, which do not all share the same value.  Whether an element is a toggle button or not can be indicated with the <code>aria-pressed</code> attribute in addition to the <code>button</code> role (if the element is not already a native button element):</p>

<ul>
 <li>If <code>aria-pressed</code> is not used, or is set to the "undefined" state, the button is not a toggle button.</li>
 <li>If <code>aria-pressed="false"</code> is used the button is a toggle button that is currently not pressed. </li>
 <li>If <code><code>aria-pressed="true"</code></code> is used the button is a toggle button that is currently pressed.</li>
 <li>if <code>aria-pressed="mixed"</code> is used, the button is considered to be partially pressed.</li>
</ul>

<p>As an example, the mute button on an audio player labeled "mute" could indicate that sound is muted by setting the <code>aria-pressed</code> state true. The label of a toggle button should not change when its state changes. In our example the label remains "Mute" with a screen reader reading "Mute toggle button pressed" or "Mute toggle button not pressed" depending on the value of <code>aria-pressed</code>. If the design were to call for the button label to change from "Mute" to "Unmute," a toggle button would not be appropriate, so the <code>aria-pressed</code> attribute would be omitted.</p>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Key</th>
   <th scope="col">Function</th>
  </tr>
  <tr>
   <td><kbd>Enter</kbd></td>
   <td>Activates the button.</td>
  </tr>
  <tr>
   <td><kbd>Space</kbd></td>
   <td>Activates the button</td>
  </tr>
 </tbody>
</table>

<p>Following button activation, focus is set depending on the type of action the button performs. For example, if clicking the button opens a dialog, the focus should move to the dialog. If the button closes a dialog, focus should returns to the button that opened the dialog unless the function performed in the dialog context logically leads to a different element. If the button alters the current context, then focus typically remains on the button, such as muting and unmuting an audio file.</p>

<h3 id="Required_JavaScript_Features">Required JavaScript Features</h3>

<h4 id="Required_event_handlers">Required event handlers</h4>

<p>Buttons can be operated by mouse, touch, and keyboard users. For native HTML <code>&lt;button&gt;</code> elements, the button's <code>onclick</code> event fires for mouse clicks and when the user presses <kbd>Space</kbd> or <kbd>Enter</kbd> while the button has focus. But if another tag is used to create a button, the <code>onclick </code>event only fires when clicked by the mouse cursor, even if <code>role="button"</code> is used. Because of this, separate key event handlers must be added to the element so that the button is be triggered when the <kbd>Space</kbd> or <kbd>Enter</kbd> key is pressed.</p>

<dl>
 <dt><code>onclick</code></dt>
 <dd>Handles the event raised when the button is activated using a mouse click or touch event.</dd>
 <dt><code>onKeyDown</code></dt>
 <dd>Handles the event raised when the button is activated using the Enter or Space key on the keyboard. (Note not the <a href="/en-US/docs/Web/Events/keypress">deprecated onKeyPress</a>)</dd>
</dl>

<h4 id="Changing_attribute_values">Changing attribute values</h4>

<h4 id="aria-pressed">aria-pressed</h4>

<p>The value of aria-pressed defines the state of a toggle button. This attribute has one of four possible values:</p>

<p><code>true</code>, <code>false</code>, <code>mixed</code>, <code>undefined</code></p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_button_example">Basic button example</h3>

<p>In this example, a span element has been given the <code>button</code> role. Because a <code>&lt;span&gt;</code> element is used, the <code>tabindex</code> attribute is required to make the button focusable and part of the page's tab order. The included CSS style is provided to make the <code>&lt;span&gt;</code> element look like a button, and to provide visual cues when the button has focus.</p>

<p>The <code>handleBtnClick</code> and <code>handleBtnKeyDown</code> event handlers perform the button's action when activated using a mouse click or the <kbd>Space</kbd> or <kbd>Enter</kbd> key. In this case, the action is to add a new name to the list of names.</p>

<p>Try the example by adding a name to the text box. The button will cause the name to be added to a list.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">    &lt;h1&gt;ARIA Button Example&lt;/h1&gt;
    &lt;ul id="nameList"&gt;&lt;/ul&gt;
    &lt;label for="newName"&gt;Enter your Name: &lt;/label&gt;
    &lt;input type="text" id="newName"&gt;
    &lt;span role="button" tabindex="0" onclick="handleCommand()" onKeyDown="handleCommand()"&gt;Add Name&lt;/span&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css">[role="button"] {
  padding: 2px;
  background-color: navy;
  color: white;
  cursor: default;
}
[role="button"]:hover,
[role="button"]:focus,
[role="button"]:active {
   background-color: white;
   color: navy;
}
ul {
    list-style: none;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js">function handleCommand(event) {
    // Handles both mouse clicks and keyboard
    // activate with Enter or Space

    // Get the new name value from the input element
    let newNameInput = document.getElementById('newName');
    let name = newNameInput.value;
    newNameInput.value = ''; // clear the text field
    newNameInput.focus();  // give the text field focus to enable entering and additional name.

    // Don't add blank entries to the list.
    if(name.length &gt; 0) {
        listItem = document.createElement('li');
        listItem.appendChild(document.createTextNode(name));

        // Add the new name to the list.
        let list = document.getElementById('nameList');
        list.appendChild(listItem);
    }
}</pre>

<p>{{EmbedLiveSample("Basic_button_example")}}</p>

<h3 id="Toggle_button_example">Toggle button example</h3>

<p>In this snippet a {{HTMLElement("span")}} element is converted to a toggle button using the <code>button</code> role and the <code>aria-pressed</code> attribute. When the button is activated, the <code>aria-pressed</code> value switches states; changing from <code>true</code> to <code>false</code> and back again.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;button type="button" onclick="handleBtnClick()" onKeyDown="handleBtnKeyDown()"&gt;
  Mute Audio
&lt;/button&gt;

&lt;span role="button" tabindex="0"
 aria-pressed="false" onclick="handleBtnClick(event)"
 onKeyDown="handleBtnKeyDown(event)"&gt;
  Mute Audio
&lt;/span&gt;

&lt;audio id="audio" src="https://soundbible.com/mp3/Tyrannosaurus%20Rex%20Roar-SoundBible.com-807702404.mp3"&gt;
  Your browser does not support the &lt;code&gt;audio&lt;/code&gt; element.
&lt;/audio&gt;

</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css">button,
[role="button"] {
    padding: 3px;
    border: 2px solid transparent;
}

button:active,
button:focus,
[role="button"][aria-pressed="true"] {
    border: 2px solid #000;
}
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js">function handleBtnClick(event) {
  toggleButton(event.target);
}

function handleBtnKeyDown(event) {
  // Check to see if space or enter were pressed
  if (event.key === " " || event.key === "Enter" || event.key === "Spacebar") { // <a href="/en-US/docs/Web/API/KeyboardEvent/key/Key_Values#Whitespace_keys">"Spacebar" for IE11 support</a>
    // Prevent the default action to stop scrolling when space is pressed
    event.preventDefault();
    toggleButton(event.target);
  }
}

function toggleButton(element) {
  var audio = document.getElementById('audio');
  // Check to see if the button is pressed
  var pressed = (element.getAttribute("aria-pressed") === "true");
  // Change aria-pressed to the opposite state
  element.setAttribute("aria-pressed", !pressed);
  // toggle the play state of the audio file
  if(pressed) {
     audio.pause();
  } else {
     audio.play();
  }
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Toggle_button_example')}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Buttons are interactive controls and thus focusable. If the <code>button</code> role is added to an element that is not focusable by itself (such as <code>&lt;span&gt;</code>, <code>&lt;div&gt;</code> or <code>&lt;p&gt;</code>) then, the <code>tabindex</code> attribute has to be used to make the button focusable.</p>

<p class="warning"><strong>Warning:</strong> Be careful when marking up links with the button role. Buttons are expected to be triggered using the <kbd>Space</kbd> or <kbd>Enter</kbd> key, while links are expected to be triggered using the <kbd>Enter</kbd> key. In other words, when links are used to behave like buttons, adding <code>role="button" </code>alone is not sufficient. It will also be necessary to add a key event handler that listens for the <kbd>Space</kbd> key in order to be consistent with native buttons.</p>

<p>When the <code>button</code> role is used, screen readers announce the element as a button, generally saying "click" followed by the button's accessible name. The accessible name is either the content of the element or the value of an <code>aria-label</code> or element referenced by an  <code>aria-labelledby</code> attribute, or description, if included.</p>

<h2 id="Best_practices">Best practices</h2>

<p>If a link performs the action of a button, giving the element <code>role="button"</code> helps assistive technology users understand the function of the element. However, a better solution is to adjust the visual design so it matches the function and ARIA role.  Where possible, it is recommended to use native HTML buttons (<code>&lt;button&gt;</code>, <code>&lt;input type="button"&gt;</code>,  <code>&lt;input type="submit"&gt;</code>, <code>&lt;input type="reset"&gt;</code> and <code>&lt;input type="image"&gt;</code>) rather than the <code>button</code> role, as native HTML buttons are supported by all user agents and assistive technology and provide keyboard and focus requirements by default, without need for additional customization.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#button","button")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#button","button")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Notes">Notes </h2>

<h3 id="ARIA_attributes_used">ARIA attributes used</h3>

<ul>
 <li><code><a href="https://www.w3.org/TR/wai-aria/roles#button">button</a></code></li>
 <li><code><a href="https://www.w3.org/TR/wai-aria-1.1/#aria-pressed">aria-pressed</a></code></li>
 <li><code>aria-expanded</code></li>
 <li><a href="/en-US/docs/">aria-haspopup</a></li>
</ul>

<h3 id="Additional_resources">Additional resources</h3>

<ul>
 <li><a href="https://www.w3.org/TR/html5/dom.html#aria-usage-note">Strong native semantics in HTML5</a></li>
 <li><a href="https://www.w3.org/TR/aria-in-html/">Notes on Using ARIA in HTML</a></li>
 <li><a href="https://www.w3.org/TR/wai-aria-practices/examples/button/button.html">Official WAI-ARIA example code</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/menubutton_role">ARIA menubutton role</a></li>
</ul>
